Subject: bug#57531: 28.1; Character encoding missing for "eo"

From: Jonathan Reeve <[email-masked]>
Date: Sat, 03 Sep 2022 16:54:52 +0000

> The characters in that post are supported by Latin-3, and I had no
> problem saving them.

It’s not about saving them, it’s about how they’re displayed. If the rest of my system correctly uses unicode for the `eo' locale, /because it’s a unicode locale,/ but emacs is the only one that guesses it should be Latin-3 instead (for no reason that I can find), then it’s emacs which incorrectly handling this locale.

> That’s okay, but then all you need to say in Emacs is
>
>   (prefer-coding-system ’utf-8)

If emacs were really following system settings, it would set the encoding to utf-8 without needing extra customization from the user, since `eo' is a UTF-8 locale. And incidentally, there’s no such locale as `eo.utf-8', from what I can tell.

> I don’t know why glibc did that, and glibc-supported systems are not
> the only ones where we want to support Esperanto.  So if the above
> simple customization fixes your problem, I’d prefer not changing the
> default for everyone.

It’s not about changing the default for everyone, it’s about fixing an incorrect character encoding, making it so that emacs correctly respects the locale’s character set. There’s no reason to have the latin-3 character set, except for backwards compatibility, but that’s irrelevant in the case of Esperanto, since I know of no program, document, or anything else that would use latin-3 for Esperanto. Since the locale for Esperanto is a relatively new invention, it doesn’t have the same history of legacy character encodings as a language like English.

In fact, not even emacs seems to define it as such, judging from this line in `locale-language-names': `("eo" . "Esperanto")'. It just seems as if the author of that variable didn’t know what character set to assign, and left it blank.